=begin 

How to Reproduce Bugsplat:
1. Start Sketchup.
2. Create some geometry.
3. Delete some of the geometry you created.
4. File -> New (nothing happens)
5. For a second time after deleting the geometry - File -> New (Bugsplat!)

If you delete entities that was already in the model, such as Sang in the Template - or if
you opened an existing file and deleted something there - nothing happens.

It only happens the second time you create a new model after you have deleted some entities
you previously created in that session.


Interesting observation:
puts model.active_entities 
It will return the same output (hexadecimal ID code) for the duration of that SU session. Even if
you open existing file or create new file.
I thought that was what caused the bugsplat - as I initially didn't remove the old observers. But 
even when I remove the observers - and they do seem to return sucessful - SU bugsplats.

=end

module TT_Debug
	# Variable to store the observer
	@observer = nil
	# Accessors
	def self.observer
		@observer
	end
	def self.observer=(value)
		@observer = value
	end
	

	class TT_AppObserver < Sketchup::AppObserver

		def onNewModel(model)
			puts "\nonNewModel"
			
			# Try to remove old observer - just incase.
			r = model.active_entities.remove_observer(TT_Debug.observer)
			puts '> Removing old observer from Model: ' + r.to_s
			
			# Create new observer
			TT_Debug.observer = TT_EntitiesObserver.new
			
			# Output to console so we can verify the result.
			puts TT_Debug.observer
			# .active_entities appear to return the same even after new model or open model
			puts model.active_entities 
			
			# Attach new observer
			r = model.active_entities.add_observer(TT_Debug.observer) #(!???)
			puts '> Adding Path Observer to Model: ' + r.to_s
		end
		
	end
	
	class TT_EntitiesObserver < Sketchup::EntitiesObserver
		# ...
	end
end

unless file_loaded?('tt_debug.rb')
	Sketchup.add_observer(TT_Debug::TT_AppObserver.new)
end
#-----------------------------------------------------------------------------
file_loaded('tt_debug.rb')